function AirAssault:StartActivity()
	collectgarbage("collect")
	
	self.GarbageTimer = Timer()
	self.SpawnTimer = Timer()
	self.HuntTimer = Timer()
	self.KeyTimer = Timer()
	self.Clock = Timer()
	
	self.LZ1 = SceneMan.Scene:GetArea("LZ1")
	self.LZ2 = SceneMan.Scene:GetArea("LZ2")
	self.landLeft = true
	
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self.startGold = 28000
		self.spawnDelay = RangeRand(90000, 120000)
		self.newDelay = 40000
		self.flakChance = 0.3
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self.startGold = 14000
		self.spawnDelay = RangeRand(60000, 80000)
		self.newDelay = 28000
		self.flakChance = 0.5
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self.startGold = 7000
		self.spawnDelay = RangeRand(40000, 60000)
		self.newDelay = 22000
		self.flakChance = 0.7
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self.startGold = 3500
		self.spawnDelay = RangeRand(30000, 50000)
		self.newDelay = 18000
		self.flakChance = 0.8
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self.startGold = 2250
		self.spawnDelay = RangeRand(20000, 40000)
		self.newDelay = 14000
		self.flakChance = 0.9
	else
		self.startGold = 1625
		self.spawnDelay = RangeRand(15000, 30000)
		self.newDelay = 10000
		self.flakChance = 1
	end
	
	if self.Difficulty > GameActivity.HARDDIFFICULTY then
		local Act = CreateACRocket("SAM Site Drop", "Air Support.rte")
		if Act then
			Act.Pos = Vector(self.LZ2:GetCenterPoint().X+SelectRand(-100,100), -50)
			Act.Team = Activity.TEAM_2
			MovableMan:AddActor(Act)
		end
	end
	
	self:SetTeamFunds(self.startGold, Activity.TEAM_1)
	
	-- Player brains
	for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
		if self:PlayerActive(player) and self:PlayerHuman(player) then
			local Brain = CreateActor("Brain Case", "Base.rte")
			Brain.Team = Activity.TEAM_1
			Brain.Pos = Vector(-40 + player * 16, 1580)
			MovableMan:AddActor(Brain)
			self:SetPlayerBrain(Brain, player)
			--self:SetObservationTarget(Brain.Pos, player)
			self.activePlayer = player
			
			-- Spawn UAV
			local UAV = CreateACRocket("UAV Spawn", "Air Support.rte")
			if UAV then
				UAV.Pos = Vector(100 + player * 50, 50)
				UAV.Team = Activity.TEAM_1
				UAV:ReloadScripts()
				MovableMan:AddActor(UAV)
				self:SwitchToActor(UAV, player, UAV.Team)
			end
		end
	end
	
	-- Add enemy brain bot
	self.CPUBrain = CreateAHuman("Brain Robot", "Base.rte")
	self.CPUBrain.Pos = SceneMan.Scene:GetArea("Brain"):GetCenterPoint()
	self.CPUBrain.Team = Activity.TEAM_2
	self.CPUBrain.AIMode = Actor.AIMODE_SENTRY
	self.CPUBrain:AddInventoryItem(RandomHDFirearm("Primary Weapons"))
	self.CPUBrain:AddInventoryItem(RandomHDFirearm("Secondary Weapons"))
	
	MovableMan:AddActor(self.CPUBrain)
	
	-- Guards
	local Ar
	local Act
	for i = 1, 14 do
		if SceneMan.Scene:HasArea("G" .. i) then
			Ar = SceneMan.Scene:GetArea("G" .. i)
			if Ar then
				Act = self:CreateEnemyActor()
				Act.Pos = Ar:GetCenterPoint()
				Act.AIMode = Actor.AIMODE_SENTRY
				
				if i % 2 == 0 then
					Act.HFlipped = true
				else
					Act.HFlipped = false
				end
				
				MovableMan:AddActor(Act)
			end
		end
	end
	
	-- AAA
	for i = 1, 6 do
		if SceneMan.Scene:HasArea("F" .. i) then
			Ar = SceneMan.Scene:GetArea("F" .. i)
			if Ar then
				if i % 2 == 0 and PosRand() < self.flakChance then
					Act = CreateACrab("Flak Slave Turret", "Air Support.rte")
				else
					Act = CreateACrab("50 cal Slave Turret", "Air Support.rte")
				end
				
				--print(Act.PresetName .. " script reload: " .. Act:ReloadScripts())
				Act.Pos = Ar:GetCenterPoint()
				Act.AIMode = Actor.AIMODE_SENTRY
				Act.Team = Activity.TEAM_2
				MovableMan:AddActor(Act)
			end
		end
	end
	
	-- Lasers
	Ar = SceneMan.Scene:GetArea("Laser1")
	if Ar then
		Act = CreateACrab("Laser Slave Turret", "Air Support.rte")
		Act.Pos = Ar:GetCenterPoint()
		Act.AIMode = Actor.AIMODE_SENTRY
		Act.Team = Activity.TEAM_2
		Act.Sharpness = 2	-- 2 == guard
		MovableMan:AddActor(Act)
	end
	
	Ar = SceneMan.Scene:GetArea("Laser2")
	if Ar then
		Act = CreateACrab("Laser Slave Turret", "Air Support.rte")
		Act.Pos = Ar:GetCenterPoint()
		Act.AIMode = Actor.AIMODE_SENTRY
		Act.Team = Activity.TEAM_2
		Act.Sharpness = 2	-- 2 == guard
		MovableMan:AddActor(Act)
	end

	-- Turret Control
	Ar = SceneMan.Scene:GetArea("Control")
	if Ar then
		Act = CreateACrab("Turret Control", "Air Support.rte")
		Act.Pos = Ar:GetCenterPoint()
		Act.AIMode = Actor.AIMODE_SENTRY
		Act.Team = Activity.TEAM_2
		Act:ReloadScripts()
		MovableMan:AddActor(Act)
	end
	
	SceneMan:MakeAllUnseen(Vector(24, 24), Activity.TEAM_1)
	local Trace = Vector(0, SceneMan.SceneHeight)
	for x = 0, SceneMan.SceneWidth-1, 12 do
		SceneMan:CastSeeRay(Activity.TEAM_1, Vector(x, 0), Trace, Vector(), 5, 4)
	end
end

function AirAssault:CreateEnemyActor()
	local Act = RandomAHuman("All", "Imperatus.rte")
	Act.Team = Activity.TEAM_2
	Act.AIMode = Actor.AIMODE_PATROL
	
	if math.random() < 0.6 then
		Act:AddInventoryItem(RandomHDFirearm("Primary Weapons", "Imperatus.rte"))
	else
		if math.random() < 0.5 then
			Act:AddInventoryItem(RandomHDFirearm("Primary Weapons"))
		else
			Act:AddInventoryItem(RandomHDFirearm("Heavy Weapons"))
		end
	end
	
	if math.random() < 0.4 then
		Act:AddInventoryItem(RandomHDFirearm("Secondary Weapons", "Imperatus.rte"))
	else
		Act:AddInventoryItem(RandomHDFirearm("Secondary Weapons"))
	end
	
	return Act
end

function AirAssault:UpdateActivity()
	if self.ActivityState == Activity.OVER then
		if self.Msg then
			FrameMan:ClearScreenText(Activity.TEAM_1)
			FrameMan:SetScreenText(self.Msg, Activity.TEAM_1, 0, 3000, true)
		end
	else
		if self.GarbageTimer:IsPastSimMS(500) then
			self.GarbageTimer:Reset()
			collectgarbage("step")
		end
		
		if not MovableMan:ValidMO(self.CPUBrain) then
			self.WinnerTeam = Activity.TEAM_1
			ActivityMan:EndActivity()
			
			local gold = math.ceil((self.startGold+300) - self:GetTeamFunds(Activity.TEAM_1))
			if not self.cheater and gold > 0 then
				self.Msg = "Completed in "
				local minutes = math.floor(self.Clock.ElapsedSimTimeS/60)
				local seconds = math.ceil(self.Clock.ElapsedSimTimeS) - minutes * 60
				self.Msg = "Competed in " .. minutes .. " minutes and " .. seconds .. " seconds, using " .. gold .. " oz of gold"
			else
				self.Msg = nil
			end
		end
		
		if MovableMan:GetMOIDCount() < 180 and self.SpawnTimer:IsPastSimMS(self.spawnDelay) then
			self.SpawnTimer:Reset()
			self.spawnDelay = self.newDelay + RangeRand(0, 14000)	--22-36s
			
			local Ship = CreateACDropShip("Drop Ship MK1", "Base.rte")
			if Ship then
				Ship.Team = Activity.TEAM_2
				Ship.Vel = Vector(0, SelectRand(5,20))
				
				if PosRand() < 0.2 and MovableMan:GetMOIDCount() < 150 then
					Ship:AddInventoryItem(self:CreateEnemyActor())
					Ship:AddInventoryItem(self:CreateEnemyActor())
					Ship.Pos = Vector(self.LZ1:GetCenterPoint().X+SelectRand(-20,20), -50)
					MovableMan:AddActor(Ship)
					
					Ship = CreateACDropShip("Drop Ship MK1", "Base.rte")
					Ship:AddInventoryItem(self:CreateEnemyActor())
					Ship:AddInventoryItem(self:CreateEnemyActor())
					Ship.Team = Activity.TEAM_2
					Ship.Vel = Vector(0, SelectRand(5,20))
					Ship.Pos = Vector(self.LZ2:GetCenterPoint().X+SelectRand(-20,20), -50)
					MovableMan:AddActor(Ship)
				else
					local spawn = true
					local controller = false
					for Act in MovableMan.Actors do
						if Act.Team == Activity.TEAM_2 then
							if Act.PresetName == "Turret Control" then
								controller = true
							elseif Act.ClassName == "ACrab" and (SceneMan.Scene:WithinArea("AA1", Act.Pos) or SceneMan.Scene:WithinArea("AA2", Act.Pos)) then
								spawn = false
								break
							end
						end
					end
					
					if spawn and controller and MovableMan:GetMOIDCount() < 170 then
						self.spawnDelay = self.newDelay + RangeRand(-4000, 2000)	--18-24s
						if PosRand() < 0.5 then
							Ship.Pos = Vector(SceneMan.Scene:GetArea("F1"):GetCenterPoint().X, -50)
						else
							Ship.Pos = Vector(SceneMan.Scene:GetArea("F6"):GetCenterPoint().X, -50)
						end
						
						local Turret = CreateACrab("50 cal Slave Turret", "Air Support.rte")
						if Turret then
							Turret.Team = Activity.TEAM_2
							Ship:AddInventoryItem(Turret)
						else
							Ship:AddInventoryItem(self:CreateEnemyActor())
						end
						
						Ship.Vel = Vector(0, 5)
						MovableMan:AddActor(Ship)
					elseif MovableMan:GetMOIDCount() < 160 then
						self.landLeft = not self.landLeft
						if self.landLeft then
							Ship.Pos = Vector(self.LZ1:GetCenterPoint().X, -50)
						else
							Ship.Pos = Vector(self.LZ2:GetCenterPoint().X, -50)
						end
						
						Ship:AddInventoryItem(self:CreateEnemyActor())
						Ship:AddInventoryItem(self:CreateEnemyActor())
						Ship.Vel = Vector(0, 5)
						MovableMan:AddActor(Ship)
					end
				end
			end
		elseif self.HuntTimer:IsPastSimMS(5000) then
			self.HuntTimer:Reset()
			
			local Target, Left, Right
			for Act in MovableMan.Actors do
				if Act.ClassName ~= "Entity" then
					if Act.Team == Activity.TEAM_1 then
						if SceneMan.Scene:WithinArea("Reinforce", Act.Pos) then
							Target = Act
						end
					else
						if SceneMan.Scene:WithinArea("Left", Act.Pos) then
							if not Left or Left.Pos.X < Act.Pos.X then
								Left = Act
							end
						elseif SceneMan.Scene:WithinArea("Right", Act.Pos) then
							if not Right or Right.Pos.X < Act.Pos.X then
								Right = Act
							end
						end
					end
				end
			end
			
			if Target then
				local Hunter
				if Left and Right then
					local l = (Target.Pos - Left.Pos).Largest
					local r = (Target.Pos - Right.Pos).Largest
					if l < r and l < 1000 then
						Hunter = Left
					elseif r < 1000 then
						Hunter = Right
					end
				else
					Hunter = Left or Right
				end
				
				if Hunter then
					Hunter.AIMode = Actor.AIMODE_GOTO
					Hunter:ClearAIWaypoints()
					Hunter:AddAIMOWaypoint(Target)
				end
			end
		end
	end
end
