
function Create(self)
	self.HomingTimer = Timer()
	self.HomingTimer:SetSimTimeLimitMS(250)
end

function Update(self)
	if self.Target then
		if MovableMan:IsActor(self.Target) then
			self.update = not self.update
			if self.update and self.HomingTimer:IsPastSimTimeLimit() then
				-- Filter the target's velocity to reduce interference
				self.TargetAvgVel = self.TargetAvgVel * 0.6 + self.Target.Vel * 0.4
				
				-- Find the velocity vector that will take us to the target
				local FutureVel = self.Vel + (self.Vel-self.LastVel)*self.timeToTarget
				local OptimalVel = SceneMan:ShortestDistance(self.Pos, self.Target.Pos+self.TargetAvgVel*self.timeToTarget, false)
				local angError = math.asin((OptimalVel.Normalized):Cross(FutureVel.Normalized))	-- The angle between FutureVel and OptimalVel
				
				self.RotAngle = self.RotAngle + math.min(math.max(angError, -0.2), 0.2)	-- Gradually turn towards the optimal velocity vector
				self.timeToTarget = self.timeToTarget * 0.7 + (math.min(OptimalVel.Largest/40, 20)+5*math.abs(angError)) * 0.3	-- Estimate the number of frames until contact with the target
				self.EmitAngle = math.max(math.min(self.EmitAngle+angError/10, 4.14), 2.14)	-- Vector thrust
				if math.abs(angError) < 0.2 then
					self.EmitAngle = self.EmitAngle * 0.7 + math.pi * 0.3	-- Gradually return the thruster to the starting position
				end
			else
				self.LastVel = self.LastVel * 0.7 + self.Vel * 0.3
				self.AngularVel = self.AngularVel * 0.97
			end
		else
			self.Target = nil
		end
	else
		local curdist = 1024
		for Act in MovableMan.Actors do
			if Act.Team ~= self.Team then
				local Dist = SceneMan:ShortestDistance(self.Pos, Act.Pos, false)
				if Dist.Magnitude < curdist and
					not SceneMan:CastStrengthRay(self.Pos, Dist, 0, Vector(), 5, 0, SceneMan.SceneWrapsX)
				then
					self.Target = Act
					self.timeToTarget = 5
					self.LastVel = Vector(self.Vel.X, self.Vel.Y)
					self.TargetAvgVel = Vector(Act.Vel.X, Act.Vel.Y)
					
					self:EnableEmission(true)
					self:TriggerBurst()
				end
			end
		end
	end
end
